// DetailBoardThreadDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardThreadDlg.h"
#include "afxdialogex.h"


// CDetailBoardThreadDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardThreadDlg, CDialog)

//CDetailBoardThreadDlg::CDetailBoardThreadDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardThreadDlg::IDD, pParent)
//{
//
//}

CDetailBoardThreadDlg::CDetailBoardThreadDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardThreadDlg::IDD, NULL)
	, board_(board)
{

}

CDetailBoardThreadDlg::~CDetailBoardThreadDlg()
{
}

void CDetailBoardThreadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_RELOAD, m_xcCheckReload);
	DDX_Control(pDX, IDC_SPIN_INTERVAL, m_xcSpinInterval);
	DDX_Control(pDX, IDC_CHECK_RETRY, m_xcCheckRetry);
	DDX_Control(pDX, IDC_CHECK_THREAD, m_xcCheckThread);
	DDX_Control(pDX, IDC_CHECK_BOARD, m_xcCheckBoard);
	DDX_Control(pDX, IDC_CHECK_MOVE, m_xcCheckMove);
	DDX_Control(pDX, IDC_SPIN_RES, m_xcSpinRes);
	DDX_Control(pDX, IDC_SPIN_DELAY, m_xcSpinDelay);
	DDX_Control(pDX, IDC_CMB_POSITION, m_xcCmbPosition);
}

void CDetailBoardThreadDlg::InitControls()
{
	m_xcCheckReload.SetCheck(board_.reload ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinInterval.SetPos32(board_.interval);
	m_xcCheckRetry.SetCheck(board_.retry ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckThread.SetCheck(board_.thread ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckBoard.SetCheck(board_.board ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckMove.SetCheck(board_.move ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinRes.SetPos32(board_.res);
	m_xcSpinDelay.SetPos32(board_.delay);

	switch (board_.position)
	{
	case sl::BoardConfig::POPUP_POSITION_CENTER:	m_xcCmbPosition.SetCurSel(0); break;
	case sl::BoardConfig::POPUP_POSITION_LEFT:		m_xcCmbPosition.SetCurSel(1); break;
	case sl::BoardConfig::POPUP_POSITION_RIGHT:		m_xcCmbPosition.SetCurSel(2); break;
	case sl::BoardConfig::POPUP_POSITION_BOTH:		m_xcCmbPosition.SetCurSel(3); break;
	default: m_xcCmbPosition.SetCurSel(0); break;
	}
}


BEGIN_MESSAGE_MAP(CDetailBoardThreadDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardThreadDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardThreadDlg bZ[W nh[


BOOL CDetailBoardThreadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinInterval.SetRange32(5, 999);
	m_xcSpinRes.SetRange32(1, 100);
	m_xcSpinDelay.SetRange32(0, 1000);

	m_xcCmbPosition.AddString(L"J[\ɕ\");
	m_xcCmbPosition.AddString(L"J[\ɕ\");
	m_xcCmbPosition.AddString(L"J[\Eɕ\");
	m_xcCmbPosition.AddString(L"EBhEŃJ[\E؂ւ");

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardThreadDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailBoardThreadDlg::OnDestroy()
{
	CDialog::OnDestroy();

	board_.reload = m_xcCheckReload.GetCheck() == BST_CHECKED;
	board_.interval = m_xcSpinInterval.GetPos32();
	board_.retry = m_xcCheckRetry.GetCheck() == BST_CHECKED;
	board_.thread = m_xcCheckThread.GetCheck() == BST_CHECKED;
	board_.board = m_xcCheckBoard.GetCheck() == BST_CHECKED;
	board_.move = m_xcCheckMove.GetCheck() == BST_CHECKED;
	board_.res = m_xcSpinRes.GetPos32();
	board_.delay = m_xcSpinDelay.GetPos32();

	switch (m_xcCmbPosition.GetCurSel())
	{
	case 0:	board_.position = sl::BoardConfig::POPUP_POSITION_CENTER; break;
	case 1:	board_.position = sl::BoardConfig::POPUP_POSITION_LEFT; break;
	case 2:	board_.position = sl::BoardConfig::POPUP_POSITION_RIGHT; break;
	case 3:	board_.position = sl::BoardConfig::POPUP_POSITION_BOTH; break;
	default: return;
	}
}


void CDetailBoardThreadDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.reload = tmp.reload;
	board_.interval = tmp.interval;
	board_.retry = tmp.retry;
	board_.thread = tmp.thread;
	board_.board = tmp.board;
	board_.move = tmp.move;
	board_.res = tmp.res;
	board_.delay = tmp.delay;
	board_.position = tmp.position;

	InitControls();
}
