// DetailBoardURLDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailBoardURLDlg.h"
#include "afxdialogex.h"


// CDetailBoardURLDlg _CAO

IMPLEMENT_DYNAMIC(CDetailBoardURLDlg, CDialog)

//CDetailBoardURLDlg::CDetailBoardURLDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailBoardURLDlg::IDD, pParent)
//{
//
//}

CDetailBoardURLDlg::CDetailBoardURLDlg(sl::BoardConfig& board)
	: CDialog(CDetailBoardURLDlg::IDD, NULL)
	, board_(board)
	, list_(board_.url)
	, m_xcList(list_, true)
{

}

CDetailBoardURLDlg::~CDetailBoardURLDlg()
{
}

void CDetailBoardURLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_EDIT_DESC, m_xcEditDesc);
	DDX_Control(pDX, IDC_EDIT_REGEX, m_xcEditRegex);
	DDX_Control(pDX, IDC_EDIT_FORMAT, m_xcEditFormat);
}

void CDetailBoardURLDlg::InitControls()
{
	int index = m_xcList.GetIndex();
	if (!list_.get(index, [this](const bbs::ReplaceElement& elem) {
		EnableControls(TRUE);
		//--------------------------------
		m_xcEditDesc.SetWindowText(elem.desc.c_str());
		m_xcEditRegex.SetWindowText(elem.regex.c_str());
		m_xcEditFormat.SetWindowText(elem.format.c_str());
	}))
	{
		EnableControls(FALSE);
		//--------------------------------
		m_xcEditDesc.SetWindowText(L"");
		m_xcEditRegex.SetWindowText(L"");
		m_xcEditFormat.SetWindowText(L"");
	}
}

void CDetailBoardURLDlg::EnableControls(BOOL enable)
{
	m_xcEditDesc.EnableWindow(enable);
	m_xcEditRegex.EnableWindow(enable);
	m_xcEditFormat.EnableWindow(enable);
}

BEGIN_MESSAGE_MAP(CDetailBoardURLDlg, CDialog)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CDetailBoardURLDlg::OnLvnItemchangedList)
	ON_BN_CLICKED(IDC_BTN_ADD, &CDetailBoardURLDlg::OnBnClickedBtnAdd)
	ON_BN_CLICKED(IDC_BTN_DEL, &CDetailBoardURLDlg::OnBnClickedBtnDel)
	ON_BN_CLICKED(IDC_BTN_UP, &CDetailBoardURLDlg::OnBnClickedBtnUp)
	ON_BN_CLICKED(IDC_BTN_DOWN, &CDetailBoardURLDlg::OnBnClickedBtnDown)
	ON_EN_CHANGE(IDC_EDIT_DESC, &CDetailBoardURLDlg::OnEnChangeEditDesc)
	ON_EN_CHANGE(IDC_EDIT_REGEX, &CDetailBoardURLDlg::OnEnChangeEditRegex)
	ON_EN_CHANGE(IDC_EDIT_FORMAT, &CDetailBoardURLDlg::OnEnChangeEditFormat)
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailBoardURLDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailBoardURLDlg bZ[W nh[


BOOL CDetailBoardURLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcList.InsertColumn(0, L"", LVCFMT_LEFT, 30);
	m_xcList.InsertColumn(1, L"", LVCFMT_LEFT, 115);
	m_xcList.InsertColumn(2, L"K\", LVCFMT_LEFT, 115);
	m_xcList.InsertColumn(3, L"uK", LVCFMT_LEFT, 115);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailBoardURLDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CDetailBoardURLDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	InitControls();

	if (pResult) { *pResult = 0; }
}

void CDetailBoardURLDlg::OnBnClickedBtnAdd()
{
	m_xcList.AddItem();
	InitControls();
}


void CDetailBoardURLDlg::OnBnClickedBtnDel()
{
	m_xcList.DelItem();
	InitControls();
}


void CDetailBoardURLDlg::OnBnClickedBtnUp()
{
	m_xcList.UpItem();
	InitControls();
}


void CDetailBoardURLDlg::OnBnClickedBtnDown()
{
	m_xcList.DownItem();
	InitControls();
}


void CDetailBoardURLDlg::OnEnChangeEditDesc()
{
	if (!IsWindow(m_xcEditDesc.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditDesc.GetWindowText(str);
		elem.desc = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardURLDlg::OnEnChangeEditRegex()
{
	if (!IsWindow(m_xcEditRegex.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditRegex.GetWindowText(str);
		elem.regex = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardURLDlg::OnEnChangeEditFormat()
{
	if (!IsWindow(m_xcEditFormat.GetSafeHwnd())) { return; }

	int index = m_xcList.GetIndex();
	if (list_.get(index, [this](bbs::ReplaceElement& elem) {
		CString str;
		m_xcEditFormat.GetWindowText(str);
		elem.format = std::wstring(str);
	}))
	{
		m_xcList.Update(index);
	}
}


void CDetailBoardURLDlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::BoardConfig();
	board_.url = tmp.url;
	m_xcList.Init();
	m_xcList.RedrawWindow();
	InitControls();
}

