// DetailNetworkDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailNetworkDlg.h"
//#include "afxdialogex.h"


// CDetailNetworkDlg _CAO

IMPLEMENT_DYNAMIC(CDetailNetworkDlg, CDialog)

CDetailNetworkDlg::CDetailNetworkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDetailNetworkDlg::IDD, pParent)
{

}

CDetailNetworkDlg::~CDetailNetworkDlg()
{
}

void CDetailNetworkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_STOP, m_xcCheckStop);
	DDX_Control(pDX, IDC_SPIN_RETRY_TIMEOUT, m_xcSpinRetryTimeout);
	DDX_Control(pDX, IDC_SPIN_RETRY_COUNT, m_xcSpinRetryCount);
	DDX_Control(pDX, IDC_SPIN_RETRY_WAIT, m_xcSpinRetryWait);
	DDX_Control(pDX, IDC_CHECK_RETRY_STOP, m_xcCheckRetryStop);
	DDX_Control(pDX, IDC_CHECK_REBUILD, m_xcCheckRebuild);
	DDX_Control(pDX, IDC_EDIT_REBUILD_COUNT, m_xcEditRebuildCount);
	DDX_Control(pDX, IDC_SPIN_REBUILD_COUNT, m_xcSpinRebuildCount);
	DDX_Control(pDX, IDC_EDIT_READER_USERAGENT, m_xcEditReaderUserAgent);
	DDX_Control(pDX, IDC_SPIN_READER_TIMEOUT, m_xcSpinReaderTimeout);
}

void CDetailNetworkDlg::InitControls()
{
	m_xcCheckStop.SetCheck(network_.stop ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinRetryTimeout.SetPos32(network_.retry.timeout);
	m_xcSpinRetryCount.SetPos32(network_.retry.count);
	m_xcSpinRetryWait.SetPos32(network_.retry.wait);
	m_xcCheckRetryStop.SetCheck(network_.retry.stop ? BST_CHECKED : BST_UNCHECKED);

	m_xcCheckRebuild.SetCheck(network_.rebuild.enable ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinRebuildCount.SetPos32(network_.rebuild.count);

	m_xcEditRebuildCount.EnableWindow(network_.rebuild.enable ? TRUE : FALSE);
	m_xcSpinRebuildCount.EnableWindow(network_.rebuild.enable ? TRUE : FALSE);

	m_xcEditReaderUserAgent.SetWindowText(network_.reader.userAgent.c_str());
	m_xcSpinReaderTimeout.SetPos32(network_.reader.timeout);
}


BEGIN_MESSAGE_MAP(CDetailNetworkDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailNetworkDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_REBUILD, &CDetailNetworkDlg::OnBnClickedCheckRebuild)
END_MESSAGE_MAP()


// CDetailNetworkDlg bZ[W nh[


BOOL CDetailNetworkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinRetryTimeout.SetRange32(0, 60000);
	m_xcSpinRetryCount.SetRange32(0, 100);
	m_xcSpinRetryWait.SetRange32(0, 60);

	m_xcSpinRebuildCount.SetRange32(1, 100);

	m_xcSpinReaderTimeout.SetRange32(0, 60000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailNetworkDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailNetworkDlg::OnDestroy()
{
	CDialog::OnDestroy();

	network_.stop = m_xcCheckStop.GetCheck() == BST_CHECKED;
	network_.retry.timeout = m_xcSpinRetryTimeout.GetPos32();
	network_.retry.count = m_xcSpinRetryCount.GetPos32();
	network_.retry.wait = m_xcSpinRetryWait.GetPos32();
	network_.retry.stop = m_xcCheckRetryStop.GetCheck() == BST_CHECKED;

	network_.rebuild.enable = m_xcCheckRebuild.GetCheck() == BST_CHECKED;
	network_.rebuild.count = m_xcSpinRebuildCount.GetPos32();

	CString userAgent;
	m_xcEditReaderUserAgent.GetWindowText(userAgent);
	network_.reader.userAgent = std::wstring(userAgent);
	network_.reader.timeout = m_xcSpinReaderTimeout.GetPos32();
}


void CDetailNetworkDlg::OnBnClickedBtnAllDefault()
{
	network_ = sl::NetworkConfig();
	InitControls();
}


void CDetailNetworkDlg::OnBnClickedCheckRebuild()
{
	network_.rebuild.enable = m_xcCheckRebuild.GetCheck() == BST_CHECKED;

	m_xcCheckRebuild.SetCheck(network_.rebuild.enable ? BST_CHECKED : BST_UNCHECKED);

	m_xcEditRebuildCount.EnableWindow(network_.rebuild.enable ? TRUE : FALSE);
	m_xcSpinRebuildCount.EnableWindow(network_.rebuild.enable ? TRUE : FALSE);
}
