#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "ResSampleView.h"
#include "ColorButton.h"
#include "FontButton.h"
#include "templatecombobox.h"

#include "DisplayResFormatDlg.h"
#include "DisplayResColor1Dlg.h"
#include "DisplayResColor2Dlg.h"
#include "DisplayResBoxDlg.h"
#include "DisplayResBackDlg.h"

// CDisplayResDlg _CAO

class CDisplayResDlg : public CDialog
{
	DECLARE_DYNAMIC(CDisplayResDlg)

public:
	CDisplayResDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CDisplayResDlg();

	void InitControls();
	void OnBnClickedBtnColor(int index);
	void OnBnClickedBtnText(int index);

// _CAO f[^
	enum { IDD = IDD_DISPLAY_RES };

	int select_;

	struct Dialog {
		Dialog(sl::ResConfig& res, CResSampleView& sample)
			: format(res, sample)
			, color1(res, sample)
			, color2(res, sample)
			, box(res, sample)
			, back(res, sample)
		{}

		CDisplayResFormatDlg format;
		CDisplayResColor1Dlg color1;
		CDisplayResColor2Dlg color2;
		CDisplayResBoxDlg box;
		CDisplayResBackDlg back;
	};

	Dialog dlg_;

	struct Item {
		Item() : dlg(NULL), index(0), init([](){}) {}

		CDialog* dlg;
		int index;
		boost::function<void()> init;
	};

	std::vector<Item> vec_;

	sl::ResConfig res_;
	std::vector<sl::ResPair> custom_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedBtnSample();
	afx_msg void OnBnClickedBtnAllDefault();
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnCbnSelchangeCmbCustom();
	afx_msg void OnDestroy();
	afx_msg void OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult);

	CResSampleView m_xcSample;
	CTemplateComboBox m_xcCmbCustom;
	CTabCtrl m_xcTab;
	
};
