#pragma once

#include "SerializeDisplay.h"
#include "SerializeOperation.h"
#include "SerializeVideo.h"
#include "SerializeDetail.h"


namespace sl {

// pX
struct PathInfo {
	std::wstring path; // URLpX/t@CpX
	std::wstring name; // `l
	std::wstring contact; // R^NgURL
};

// AXyNg
typedef enum {
	WINDOW_ASPECT_DEFAULT = 0, // ftHg
	WINDOW_ASPECT_NONE = 1, // EBhEɍ킹
	WINDOW_ASPECT_CUSTOM = 2, // [U[ݒ
} WINDOW_ASPECT;

// sDx
typedef enum {
	PROCESS_PRIORITY_IDLE, // 
	PROCESS_PRIORITY_BELOW_NOMAL, // ʏȉ
	PROCESS_PRIORITY_NORMAL, // ʏ
	PROCESS_PRIORITY_ABOVE_NORMAL, // ʏȏ
	PROCESS_PRIORITY_HIGH, // 
	PROCESS_PRIORITY_REALTIME, // A^C
} PROCESS_PRIORITY;

// EBhEݒ
struct WindowControl {
	// \
	struct Show {
		Show()
			: topmost(false)
			, title(true)
			, frame(true)
			, bbs(true)
			, seek(true)
			, status(true)
			, edit(false)
		{}

		bool topmost; // őOʕ\
		bool title; // ^Cgo[\
		bool frame; // t[\
		bool bbs; // BBSo[\
		bool seek; // V[No[\
		bool status; // Xe[^Xo[\
		bool edit; // BBSo[ݗ\
	};

	// 䗦Kp
	struct Ratio {
		Ratio() : fixed(true), play(false), height(true), inscribe(true) {}

		bool fixed; // TCYύXɔ䗦Œ
		bool play; // ĐJnɎIɔ䗦Kp
		bool height; // 䗦KpƂ
		bool inscribe; // 䗦KpƂ̃TCYɎ߂
	};

	// Xibv
	struct Snap {
		Snap() : screen(true), window(true) {}

		bool screen; // XN[Xibv
		bool window; // EBhEXibv
	};

	// S
	struct Fullscreen {
		Fullscreen() : hide(false), floating(false), mouse(true), topmost(true) {}

		bool hide; // o[IɉB
		bool floating; // o[IɉBƂɃt[eBO\
		bool mouse; // IɃ}EXJ[\
		bool topmost; // őOʕ\
	};

	// ő剻
	struct Maximize {
		Maximize() : fullscreen(false), taskbar(true) {}

		bool fullscreen; // Sʉ
		bool taskbar; // ^XNo[̈BȂ
	};

	// ^Cgo[
	struct Title {
		Title() : size(false), source(false) {}

		bool size; // ʃTCY\
		bool source; // \[XTCY\
	};

	// Xe[^Xo[
	struct Status {
		// `l
		struct Channel {
			Channel() : name(true), type(false), genre(false), comment(false), playing(false), relay(false) {}

			bool name; // `l
			bool type; // ^Cv
			bool genre; // W/ڍ
			bool comment; // Rg
			bool playing; // A[eBXg/^Cg/Ao
			bool relay; // Xi[/[
		};

		Status() : fixed(false), size(false), fps(true) {}

		bool fixed; // Œ肷
		bool size; // ʃTCY\
		bool fps; // ItCAfps\
		Channel channel;
	};

	// V[No[
	struct Seek {
		Seek() : filename(true) {}

		bool filename; // t@C\
	};

	// BBSo[
	struct BBS {
		BBS() : counter(true) {}

		bool counter; // XVJE^\
	};

public:
	WindowControl()
		: aspect(WINDOW_ASPECT_DEFAULT)
		, priority(PROCESS_PRIORITY_NORMAL)
		, stop(true)
		, zoom(false)
	{}

	int aspect; // AXyNg̃^Cv
	int priority; // sDx
	bool stop; // Đj^[dOFFƃX^oC}~
	bool zoom; // Nɔ{100%

	Show show; // \
	Ratio ratio; // 䗦Kp
	Snap snap; // Xibv
	Fullscreen fullscreen; // Sʉ
	Maximize maximize; // ő剻
	Title title; // ^Cgo[
	Status status; // Xe[^Xo[
	Seek seek; // V[No[
	BBS bbs; // BBSo[

	DWORD getPriority()
	{
		switch(priority)
		{
		case PROCESS_PRIORITY_IDLE:			return IDLE_PRIORITY_CLASS;
		case PROCESS_PRIORITY_BELOW_NOMAL:	return BELOW_NORMAL_PRIORITY_CLASS;
		case PROCESS_PRIORITY_NORMAL:		return NORMAL_PRIORITY_CLASS;
		case PROCESS_PRIORITY_ABOVE_NORMAL:	return ABOVE_NORMAL_PRIORITY_CLASS;
		case PROCESS_PRIORITY_HIGH:			return HIGH_PRIORITY_CLASS;
		case PROCESS_PRIORITY_REALTIME:		return REALTIME_PRIORITY_CLASS;
		default: break;	
		}
		return NORMAL_PRIORITY_CLASS;
	}
};

// Xe[^Xo[
struct StatusFormat {
	struct Format {
		Format()
			: enable(true)
			, type(0)
			
		{}

		bool enable; // ύX
		int type; // 
	};

	Format name; // O
	Format bitrate; // rbg[g
	Format fps; // fps
	Format size; // ʃTCY
	Format time; // Đ
	Format volume; // 
};

// ItCĐ[h
typedef enum {
	PLAY_MODE_NORMAL,
	PLAY_MODE_REPEAT,
	PLAY_MODE_FOLDER,
	PLAY_MODE_FOLDER_LOOP,
} PLAY_MODE;

// ItCĐ
struct PlayControl {
	PlayControl()
		: mode(PLAY_MODE_NORMAL)
	{}

	int mode; // ItCĐ[h
};

// CɓfN
struct Link {
	std::wstring title;
	std::wstring url;
};

typedef std::vector<Link> Links;

// e_CAOݒ
struct DialogConfig {
	// BBSo[j[
	struct BBS {
		BBS()
			: sage(true)
		{}

		bool sage; // sageŏ
	};

	// XbhI
	struct Thread {
		Thread()
			: width(600)
			, height(300)
			, stop(false)
			, stretch(true)
			, datetime(true)
		{
			column[0] = 0; // _~[
			column[1] = 40; // No.
			column[2] = 300; // ^Cg
			column[3] = 50; // X
			column[4] = 60; // 
			column[5] = 110; // Since
		}

		int width; // EBhE
		int height; // EBhE
		std::array<int, 6> column; // J
		bool stop; // IXbh\
		bool stretch; // JLk
		bool datetime; // \
		Links links;
	};

	// t@C/URLJ
	struct File {
		File()
			: width(600)
			, height(150)
		{}

		int width; // EBhE
		int height; // EBhE
	};

	// O
	struct Log {
		Log()
			: graph(true)
			, filter(false)
			, bbs(false)
			, peercast(false)
			, none(false)
		{}
		
		bool graph; // Ot
		bool filter; // tB^
		bool bbs; // BBS
		bool peercast; // PeerCast
		bool none; // ̑
	};

	BBS bbs; // BBSo[j[
	Thread thread; // XbhI
	File file; // t@C/URLJ
	Log log; // O
};

// IvV_CAO
struct OptionConfing {
	// I/^u
	struct Select {
		Select()
			: option(0)
			, board(0)
			, res(0)
		{}
		int option; // IvV
		int board; // ڍאݒ/BBSo[^u
		int res; // CAEg/X|bvAbv^u
	};

	OptionConfing()
	{}

	Select select; // I/^u
};

//////////////////////////////////////////////////////////////

// LOGFONT
void put(XmlParser& p, const LOGFONT& font);
void get(const XmlParser& p, LOGFONT& font);

void put(XmlParser& root, const VideoConfig& video);
void get(const XmlParser& root, VideoConfig& video);

void put(XmlParser& root, const DetailConfig& detail);
void get(const XmlParser& root, DetailConfig& detail);

void put(XmlParser& root, const OperationConfig& operation);
void get(const XmlParser& root, OperationConfig& operation);

void put(XmlParser& root, const DisplayConfig& display);
void get(const XmlParser& root, DisplayConfig& display);







// ۑf[^
struct SerializeValues {
	PathInfo recent; // ŋ߂̃pX 

	RECT placement; // EBhEʒu

	WindowControl window; // EBhEݒ

	PlayControl play; // ItCĐ

	dsp::AudioControl audio; // I[fBI

	StatusFormat format; // Xe[^Xo[

	DialogConfig dialog; // e_CAOݒ

	OptionConfing option; // IvV_CAO
	VideoConfig video; // f
	DetailConfig detail; // ڍאݒ
	OperationConfig operation; // ݒ
	DisplayConfig display; // \ݒ

	////////////////////////////////////////
	void load(const std::wstring& current);
	void save(const std::wstring& current);
};

} // namespace sl