#pragma once


#include "ChannelDlg.h"



struct StatusLayout {
	StatusLayout()
		: width(0)
		, enable(true)
		, type(0)
		, old(0)
	{}

	int width;
	bool enable;
	int type;
	int old;
};

class StatusLayoutManager {
public:
	CRect nameRect(const CRect& src);
	CRect textRect(const CRect& src);
	CRect bitrateRect(const CRect& src);
	CRect fpsRect(const CRect& src);
	CRect sizeRect(const CRect& src);
	CRect timeRect(const CRect& src);
	CRect sliderRect(const CRect& src);
	CRect volumeRect(const CRect& src);
	CRect volumeSliderRect(const CRect& src);

	int rightPos(const CRect& src);



	StatusLayout name;
	StatusLayout text;
	StatusLayout bitrate;
	StatusLayout fps;

	StatusLayout size;
	StatusLayout time;
	StatusLayout slider;// enable͒x\̂߂̈ꎞgpŕۑȂ
	StatusLayout volume;// enableŃXC_[\؂ւ
};

// CStatusDlg _CAO

class CStatusDlg : public CDialog
{
	DECLARE_DYNAMIC(CStatusDlg)

public:
	CStatusDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CStatusDlg();

// _CAO f[^
	enum { IDD = IDD_STATUS };

private:
	CFont font_;
	int height_;
	sl::StatusConfig cfg_;

	std::wstring desc_;

	// `lXe[^X
	CChannelDlg channel_;

	bool click_;
	bool capture_;
	bool show_;

	std::wstring nametext_;

	StatusLayoutManager layout_;

	bool statusRight(CDC& dc, const RECT& target, int& right);
	bool statusLeft(CDC& dc, const RECT& target, int left, int right);
	bool statusLeft2(CDC& dc, const RECT& target, int left, int right);

	bool getChannelStatusText(std::wstring& text);
	void SetMouseHover();

public:
	bool isValid() { return ::IsWindow(GetSafeHwnd()) == TRUE && getShow(); }
	void setShow(bool show) { show_ = show; ShowWindow(show ? SW_SHOWNA : SW_HIDE); EnableWindow(show ? TRUE : FALSE); }
	bool getShow() { return show_; }

	int getHeight() { return height_; }

	void setNametext(const std::wstring& nametext) { nametext_ = nametext; }
	void clearNametext() { nametext_.clear(); }

	void SetConfig(const sl::StatusConfig& cfg);
	void SetConfig(const sl::ChannelConfig& cfg) { channel_.SetConfig(cfg); }

	void setDesc(const std::wstring& desc);
	void clearDesc();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);

	//bool ShowTooltip(const CRect& rect, const CPoint& point);
	
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
};
